import MemTypes::*;
import EHR::*;
import Vector::*;

typedef 16 LineNum;
typedef Bit#(TLog#(LineNum)) LineIdx;

interface NextAddressPredictor;
    method Addr prediction(Addr pc);
    method Action update(Addr pc, Addr target);
endinterface

(* synthesize *)
module mkBTB(NextAddressPredictor);
    Vector#(LineNum, EHR2#(Addr))    tagArr <- replicateM(mkEHR2U);
    Vector#(LineNum, EHR2#(Addr)) targetArr <- replicateM(mkEHR2U);

    method Addr prediction(Addr pc);
        LineIdx index = truncate(pc >> 2);
        let tag = tagArr[index].r1;
        let target = targetArr[index].r1;
        if (tag==pc) return target; else return (pc+4);
    endmethod

    method Action update(Addr pc, Addr target);
        LineIdx index = truncate(pc >> 2);
        tagArr[index].w0(pc);
        targetArr[index].w0(target);  
    endmethod
endmodule
