import Vector::*;
import ProcTypes::*;
import MemTypes::*;
import EHR::*;

interface RFile;
    method Action wr( Rindx rindx, Data data );
    method Data rd1( Rindx rindx );
    method Data rd2( Rindx rindx );
endinterface

(* synthesize *)
module mkEHRBypassRFile( RFile );
    Vector#(32, EHR2#(Data)) rfile <- replicateM(mkEHR2(0));

    method Action wr( Rindx rindx, Data data );
        if(rindx!=0) rfile[rindx].w0(data);
    endmethod

    method Data rd1( Rindx rindx );
        return rfile[rindx].r1;
    endmethod

    method Data rd2( Rindx rindx );
        return rfile[rindx].r1;
    endmethod
endmodule
