import Vector::*;
import ProcTypes::*;
import EHR::*;

interface Scoreboard#(numeric type size);
    method Action insert(Maybe#(Rindx) r);
    method Action remove;
    method Bool search(Maybe#(Rindx) s1, Maybe#(Rindx) s2);
endinterface

module mkScoreboard(Scoreboard#(size));
    Vector#(size, EHR2#(Maybe#(Rindx)))   arr <- replicateM(mkEHR2(Invalid));
    Reg#(Bit#(TAdd#(TLog#(size),1)))     iidx <- mkReg(0);
    Reg#(Bit#(TAdd#(TLog#(size),1)))     ridx <- mkReg(0);
    EHR#(3, Bit#(TAdd#(TLog#(size),1)))   cnt <- mkEHR(0);
    
    method Action insert(Maybe#(Rindx) r) if(cnt[1]!=fromInteger(valueOf(size)));
        arr[iidx].w1(r);
        iidx <= iidx==fromInteger(valueOf(size))-1 ? 0 : iidx + 1;
        cnt[1] <= cnt[1] + 1;
    endmethod

    method Action remove if(cnt[0]!=0);
        arr[ridx].w0(Invalid);
        ridx <= ridx==fromInteger(valueOf(size))-1 ? 0 : ridx + 1;
        cnt[0] <= cnt[0] - 1;
    endmethod

    method Bool search(Maybe#(Rindx) s1, Maybe#(Rindx) s2);
        Bit#(size) r = 0;
        for (Integer i=0; i<valueOf(size); i=i+1)
            r[i] = pack(dataHazard(s1, s2, arr[i].r1));
        return r!=0;
    endmethod
endmodule
